import { EditorView, ViewUpdate } from '@codemirror/view';
import { Extension, Facet } from '@codemirror/state';

declare function tooltips(): Extension;
interface Tooltip {
    pos: number;
    end?: number;
    create(view: EditorView): TooltipView;
    style?: string;
    above?: boolean;
    strictSide?: boolean;
}
interface TooltipView {
    dom: HTMLElement;
    mount?(view: EditorView): void;
    update?(update: ViewUpdate): void;
    positioned?(): void;
}
declare const showTooltip: Facet<Tooltip, readonly Tooltip[]>;
declare function hoverTooltip(source: (view: EditorView, pos: number, side: -1 | 1) => Tooltip | null, options?: {
    hideOnChange?: boolean;
}): Extension;

export { Tooltip, TooltipView, hoverTooltip, showTooltip, tooltips };
